// Must include <clientapi.h>

class DALine;
class DARev;
class DATextTable;

class DAFile
{
public:
	DAFile( DATextTable* table );
	~DAFile(void);

	void setPath( const StrPtr* path );
	DARev* addRev( int num, int change );
	DALine* addLine( const StrPtr* text, int up, int lo );

	const StrPtr&	getPath() { return path; };

	DARev*	getRev( int num );
	DARev*	getNextRev( int num );
	DARev*	getLastRev( int num );
	int		head();

	DALine* firstLine();
	DALine* lastLine();
	DALine* zeroLine() { return lineZero; };

private:
	StrBuf path;

	DARev**	revArray;
	int		arrSize;

	DALine* lineZero;
	DATextTable* textTable;
};
