#include "DATooth.h"

#include <stdio.h>
#include "DALine.h"

DATooth::DATooth( DALine* l )
: line( l )
{
	prev = this;
	next = this;
	if ( !line ) return;

	if ( line->getTooth() ) fprintf( stderr, "Tooth contention detected.\n" );
	else line->setTooth( this );
}

DATooth::~DATooth(void)
{
	if ( line ) line->setTooth( 0x0 );

	prev->next = next;
	next->prev = prev;
}

void DATooth::prependTooth( DATooth* tooth )
{
	tooth->next = this;
	tooth->prev = prev;
	prev->next = tooth;
	this->prev = tooth;
}
