class Cell;
class Hive;

class Bee
{
public:
	Bee( Hive* h );
	~Bee(void);

	void paint();
	void step();

	void setPos( float x, float y ) { p_x = x; p_y = y; };

	float degree() const { return angle; };
	Cell* inOrbit() const { return curr; };

	void setTargetCell( Cell* c );
	void setTargetSpin( float s, float a ) { angle_v_target = s; angle_a_max = a; };

	void orbit( Cell* c );
	void leave();

private:
	Hive* hive;
	Cell* curr;
	Cell* targ;

	float angle;
	float angle_v;
	float angle_v_target;
	float angle_a_max;

	float p_x;
	float p_y;
	float v_x;
	float v_y;
	float v_x_target;
	float v_y_target;
};

#define BEE_MAX_V 1.5
#define BEE_MAX_A 0.02
#define BEE_ORBIT_RAD 10
