
// The ClientLogUser subclass of ClientUser is used to build a FileLogCache.
// It should only be used with calls to "p4 filelog".  If perchance it should
// discover more than one file, it'll quietly ignore all but the first one.

class ClientLogUser : public ClientUser  
{
public:
	ClientLogUser( FileHead* w, Error* e );
	virtual ~ClientLogUser();

	// This method reads in a filelog and dumps it into a FileHead object.
	void OutputInfo( char, const_char* );

	// Stick errors into the "error" member for later analysis.
	void HandleError( Error* err );

	FileHead* working; // This is the FileHead that we'll be modifying.
	Error* error;
private:
	bool doneone; // error check - set to true after level == '0'
	bool toomany; // error check - set to true if (level == '0' && doneone)
};
