class FileRev;
class QTreeRevText;

// QTreeRevBall: a circle representing a revision. 

class QTreeRevBall : public QCanvasPolygonalItem 
{
public:
	QTreeRevBall( QCanvas* can, FileRev* rev, int y, int vspace, bool trun );
	virtual ~QTreeRevBall();

	// These are implemented for QCanvas compatibility. 
	virtual QPointArray areaPoints() const;
	virtual void drawShape( QPainter& p );

	// RTTI for collision detection. 
	int rtti() const { return RTTI_REV; };

	// Pop up a dialog. 
	void InfoDialog( QWidget* parent );

	// Returns "filename#rev" 
	StrBuf Name();

	// Binary file?
	bool IsBinary();

	QString Tip() { return QString( Name().Text() ); };

	// Set color.
	void UpdateBrush();

	QTreeRevText* revtext;

private:
	FileRev* rev;
};
