// SquidDynamicPane.h: interface for the SquidDynamicPane class.
//
//////////////////////////////////////////////////////////////////////

class SquidPortrait;

#include <qframe.h>
#include <qimage.h>
#include <qslider.h>
#include <qscrollview.h>

class SquidDynamicPane : public QFrame  
{
	Q_OBJECT
public:
	SquidDynamicPane( QWidget* parent, QImage *f1, QImage *f2 );
	virtual ~SquidDynamicPane();

	void resizeEvent( QResizeEvent* e );

	void HScroll( int pct );
	void VScroll( int pct );
	void Redraw();
	
	void GenDiffMask( int tol );
	void SetBlendSize( int size );

	bool maskdiffs;
	bool** diffmask;
	SquidPortrait* pic;
	QScrollView* scroll;
	int blendsize;
public slots:
	void StippleStep( int s, bool f2w );
	void Blend( int b );
	void Stipple( int s );

private:
	QImage *f1, *f2, *img;
	QSlider* slider;
	int oldslid;
};
