#include <qapplication.h>
#include <qimage.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qmainwindow.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qscrollview.h>
#include <qslider.h>
#include <qsplitter.h>
#include <qtoolbutton.h>

#include "SquidPortrait.h"
#include "SquidStaticPane.h"
#include "SquidDynamicPane.h"
#include "SquidDiffBlocker.h"
#define SQUIDMAINWINDOW_H
#include "SquidMainWindow.h"

int main ( int argc, char** argv )
{
	QApplication myapp( argc, argv );

	argc--; 
	argv++;

	QImage* file1 = NULL;
	QImage* file2 = NULL;
	bool l = false;
	bool r = false;
	QString arg, right, left;
	while ( argc )
	{
		arg = QString( *argv );
		argc--;
		argv++;

		if ( arg == "-l" && argc && !l && !r )
		{
			l = true;
		}
		else if ( arg == "-r" && argc && !l && !r )
		{
			r = true;
		}
		else if ( l )
		{
			left = arg;
			l = false;
		}
		else if ( r )
		{
			right = arg;
			r = false;
		}
		else if ( !file1 )
		{
			file1 = new QImage( arg );
			if ( left.isEmpty() ) left = arg;
		}
		else if ( !file2 )
		{
			file2 = new QImage( arg );
			if ( right.isEmpty() ) right = arg;
		}
		else
		{
			QMessageBox::critical
				(
				NULL,
				"SQUID Error",
				"Usage: squid [-l lname] [-r rname] file1 file2",
				QMessageBox::Ok,
				QMessageBox::NoButton,
				QMessageBox::NoButton
				);
			return 1;
		}
	}

	if ( !file1 || !file2 )
	{
		QMessageBox::critical
			(
			NULL,
			"SQUID Error",
			"Usage: squid [-l lname] [-r rname] file1 file2",
			QMessageBox::Ok,
			QMessageBox::NoButton,
			QMessageBox::NoButton
			);
		return 1;
	}

	if ( file1->isNull() || file2->isNull() )
	{
		QMessageBox::critical
			(
			NULL,
			"SQUID Error",
			"Couldn't load images!  (Unsupported format or nonexistent files?)",
			QMessageBox::Ok,
			QMessageBox::NoButton,
			QMessageBox::NoButton
			);
		return 1;
	}
	SquidMainWindow* sw = new SquidMainWindow
		( file1, file2, left, right );
	myapp.setMainWidget( sw );
	return myapp.exec();
}
